! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure verify16.prg  to verify MIDAS commands
!  for big data objects
! 
!  K. Banse     090429, 090804
!
!  use as @@ verify16 ffffffffffffffffffff         with f = 1 or 0 (on/off)
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 111111111111111 n "Enter control flags for entries: "
!
define/local loop/i/1/1 0
define/local rval/r/1/1 0. ? +lower
define/local ival/i/1/5 0 all +lower
define/local seconds/i/1/2 0,0 ? +lower
define/local rcorr/r/1/20 0. all +lower
define/local icorr/i/1/20 0 all +lower
define/local errsum/i/1/1 0 ? +lower
define/local ccc/c/1/15 000000000000000
define/local secs/i/1/2 0,0 ? +lower
define/local myvals/i/1/2 0,0 ? +lower
define/local longdir1/c/1/60 verylongdirectoryforfilestotestmidas ? +lower
define/local longdir2/c/1/60 anotherverylongdirectoryforfilestotestmidas ? +lower
!
delete/temp                             !get rid of old temporary files
! 
write/key sizez/i/1/5 600,600,0,0,0
write/key dispyes/i/1/2 0,0
write/key stop/i/1/1 0
!
write/out +------------------------------------------+
write/out Start of procedure verify16.prg
write/out +------------------------------------------+
!
seconds(1) = m$secs()
write/key ccc {p1}
set/format i1
do loop = 1 14
   if ccc({loop}:{loop}) .eq. "1" @@ verify16,000{loop}
   if errsum .gt. 0 then
      write/out "We got problems with entry 000{loop} in verify16.prg!"
      stop = 1
      return
   endif
enddo
seconds(2) = m$secs()
mid$info(8) = seconds(2)-seconds(1)
! 
!
write/out +------------------------------------------+
write/out procedure verify16.prg:
write/out Total time elapsed = {mid$info(8)} seconds.
write/out All tests o.k. - you deserve a coffee now...
write/out +------------------------------------------+
!
!  here the different sub-procedures
!
entry 0001
!
write/out test of averaging images
write/out "------------------------"
! 
write/out > create/image a1 2,256,256 ? ? 200.
create/image a1 2,256,256 ? ? 200.
write/out > create/image a2 2,256,256 ? ? 400.
create/image a2 2,256,256 ? ? 400.
write/out > create/image a3 2,256,256 ? ? 100.
create/image a3 2,256,256 ? ? 100.
write/out > create/image a4 2,256,256 ? ? 500.
create/image a4 2,256,256 ? ? 500.
!
write/out > write/descr a1 weight/r/1/1 2.
write/descr a1 weight/r/1/1 2.
write/out > write/descr a2 weight/r/1/1 1.
write/descr a2 weight/r/1/1 1.
write/out > write/descr a3 weight/r/1/1 3.
write/descr a3 weight/r/1/1 3.
! for a4 weight is defaulted to 1.0
!
write/out > average/weights out1 = a1,a2,a3,a4
average/weights out1 = a1,a2,a3,a4
read/image out1
write/out > average/weights out2 = a1,a2,a3,a4 m
average/weights out2 = a1,a2,a3,a4 m
read/image out2
if {out1[@100,@100]} .ne. 228.571 then
   write/out error1
   return
endif
if {out1[@100,@100]} .ne. {out2[@100,@100]} then
   write/out error2
   return
endif
!
write/out > write/descr a2 weight/r/1/1 0.
write/descr a2 weight/r/1/1 0.
write/out > average/weights out1 = a1,a2,a3,a4
average/weights out1 = a1,a2,a3,a4
read/image out1
if {out1[@100,@100]} .ne. 200.0 then
   write/out error3
   return
endif
write/out > write/descr a2 weight/r/1/1 1.5
write/descr a2 weight/r/1/1 1.5
write/out > average/weights out1 = a1,a2,a3,a4
average/weights out1 = a1,a2,a3,a4
read/image out1
if {out1[@100,@100]} .ne. 240.0 then
   write/out error4
   return
endif
write/out > average/images out2 = a1,a2,a3,a4
average/images out2 = a1,a2,a3,a4
read/image out2
if {out2[@100,@100]} .ne. 300.0 then
   write/out error5
   return
endif
write/out > write/descr a1 weight/r/1/1 1.
write/descr a1 weight/r/1/1 1.
write/out > write/descr a2 weight/r/1/1 1.
write/descr a2 weight/r/1/1 1.
write/out > write/descr a3 weight/r/1/1 1.
write/descr a3 weight/r/1/1 1.
write/out > write/descr a3 weight/r/1/1 1.
write/descr a3 weight/r/1/1 1.
write/out > average/weights out1 = a1,a2,a3,a4
average/weights out1 = a1,a2,a3,a4
read/image out1
if {out1[@100,@100]} .ne. {out1[@100,@100]} then
   write/out error6
   return
endif
!
entry 0002
return			!this takes too long on systems with less memory...
!
write/out test of creating big images 
write/out "---------------------------"
! 
$rm -f xbig.big
! 
if mid$sys(31:32) .eq. "64" then
   define/local inni/i/1/1 500
else
   define/local inni/i/1/1 250
endif
! 
write/keyw bigno/s/1/2 1234,1234
bigno(1) = 1000000 * inni
bigno(2) = bigno(1) * 4
set/format i1
write/out > create/image xbig.big 2,1000000,{inni} ? poly 27,1.,1.
create/image xbig.big 2,1000000,{inni} ? poly 27,1.,1. 
$ls -hl xbig.big
write/out > read/descr xbig.big
read/descr xbig.big
write/out > read/image xbig.big @100000,@100,30
read/image xbig.big @100000,@100,30
write/out > statistics/image xbig.big
statistics/image xbig.big
! $rm -f xbig.big
!
! 
entry 0003
!
!
entry 0004
!
entry 0005
!
! 
entry 0006
!
entry 0007
!
!
entry 0008
!
entry 0009
!
entry 00010
!
entry 00011
!
entry 00012
!
! 
entry 00013
! 
entry 00014
!



